      SUBROUTINE stream_scale (b,c,scalar,n)
      REAL*8 c(n),b(n),scalar
      INTEGER AHEAD
      PARAMETER (AHEAD=128)

      IF (n.LE.AHEAD+1) THEN
         DO j=1,n
            b(j) = scalar*c(j)
         END DO
      ELSE
         DO j = 1,n-AHEAD,16
!IBM*       CACHE_ZERO (b(j+AHEAD))
            DO i=0,15
               b(j+i) = scalar*c(j+i)
            END DO
         END DO
         DO j=n-AHEAD+1,n
            b(j) = scalar*c(j)
         END DO
      END IF
      END
